<?php

namespace App\Console\Commands\Intuit;

use Illuminate\Console\Command;

use App\Models\{ProviderOauth,User};
use App\Jobs\AccountingAccountSync as Job;

/**
 * Synchronise Customers with Accounts
 */
class AccountSync extends Command
{
	private const provider = 'intuit';

	/**
	 * The name and signature of the console command.
	 *
	 * @var string
	 */
	protected $signature = 'intuit:account:sync'
		.' {user? : User Email}';

	/**
	 * The console command description.
	 *
	 * @var string
	 */
	protected $description = 'Synchronise accounts with quickbooks';

	/**
	 * Execute the console command.
	 *
	 * @return int
	 */
	public function handle()
	{
		$uo = User::where('email',$this->argument('user') ?: config('osb.admin'))->singleOrFail();

		$so = ProviderOauth::where('name',self::provider)->singleOrFail();
		if (! ($to=$so->token($uo)))
			abort(500,sprintf('Unknown Tokens for [%s]',$uo->email));

		Job::dispatchSync($to);

		return self::SUCCESS;
	}
}